<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';

interface ColoredLine {
  color: string;
  width: number;
}

export default Vue.extend({
  name: 'ColoredLine',
  props: {
    lineColors: {
      type: Array as PropType<ColoredLine[]>,
      required: true,
    },
  },
});
</script>

<template>
  <div class="color-line">
    <div
      v-for="(segment, index) in lineColors"
      :key="index"
      class="color-segment"
      :style="{ backgroundColor: segment.color, width: segment.width }"
    >
      <span :style="{ backgroundColor: segment.color }" />
    </div>
  </div>
</template>

<style scoped lang="scss">
.color-segment {
  position: relative;

  span {
    position: absolute;
    top: 0;
    right: -4px;
    border-radius: 0 10px 10px 0;
    width: 10px;
    height: 100%;
    z-index: 1;
  }
}

.color-line {
  display: flex;
  height: 10px;
  overflow-x: hidden;

  div {
    height: 100%;
  }
}
</style>
